diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/CollectionDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/CollectionDetailElement.java
index 875015bf8..1e7acca7c 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/CollectionDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/CollectionDetailElement.java
@@ -10,15 +10,14 @@
 
 package eu.etaxonomy.taxeditor.ui.section.occurrence;
 
+import eu.etaxonomy.cdm.model.agent.Institution;
 import eu.etaxonomy.cdm.model.occurrence.Collection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
 import eu.etaxonomy.taxeditor.ui.element.ToggleableTextElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.CollectionSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.InstitutionSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -42,9 +41,9 @@ public class CollectionDetailElement extends
 
 	private TextWithLabelElement text_townOrLocation;
 
-	private InstitutionSelectionElement selection_institute;
+	private EntitySelectionElement<Institution> selection_institute;
 
-	private CollectionSelectionElement selection_superCollection;
+	private EntitySelectionElement<Collection> selection_superCollection;
 
 	/**
 	 * <p>
@@ -88,16 +87,16 @@ public class CollectionDetailElement extends
 		text_townOrLocation = formFactory.createTextWithLabelElement(
 				formElement, "Town Or Location", entity.getTownOrLocation(),
 				style);
-		selection_institute = (InstitutionSelectionElement) formFactory
-				.createSelectionElement(SelectionType.INSTITUTION,
+		selection_institute = formFactory
+				.createSelectionElement(Institution.class,
 						getConversationHolder(), formElement, "Institute",
 						entity.getInstitute(),
-						InstitutionSelectionElement.DEFAULT, style);
-		selection_superCollection = (CollectionSelectionElement) formFactory
-				.createSelectionElement(SelectionType.COLLECTION,
+						EntitySelectionElement.ALL, style);
+		selection_superCollection = formFactory
+				.createSelectionElement(Collection.class,
 						getConversationHolder(), formElement,
 						"Super Collection", entity.getSuperCollection(),
-						CollectionSelectionElement.DEFAULT, style);
+						EntitySelectionElement.ALL, style);
 	}
 
 	/*
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/CollectionWizardPage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/CollectionWizardPage.java
index cf909e549..9c9574b31 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/CollectionWizardPage.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/CollectionWizardPage.java
@@ -16,8 +16,8 @@ import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.occurrence.Collection;
 import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 
 /**
@@ -55,7 +55,7 @@ public class CollectionWizardPage extends AbstractCdmEntityWizardPage<Collection
 	 */
 	/** {@inheritDoc} */
 	@Override
-	public AbstractCdmDetailElement createElement(ICdmFormElement rootElement) {
+	public AbstractCdmDetailElement<Collection> createElement(ICdmFormElement rootElement) {
 		CollectionDetailElement collectionDetailElement = (CollectionDetailElement) formFactory.createCdmDetailElement(DetailType.COLLECTION, rootElement, SWT.NULL);
 		collectionDetailElement.setEntity(entity);
 		return collectionDetailElement;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitBaseDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitBaseDetailElement.java
index 8b4bca906..8422ed5d9 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitBaseDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitBaseDetailElement.java
@@ -14,17 +14,18 @@ import org.eclipse.ui.forms.widgets.Section;
 
 import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
 import eu.etaxonomy.cdm.api.facade.MethodNotSupportedByDerivedUnitTypeException;
+import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.cdm.model.occurrence.PreservationMethod;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 import eu.etaxonomy.taxeditor.store.StoreUtil;
 import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
+import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.NameSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -44,7 +45,7 @@ public class DerivedUnitBaseDetailElement extends
 
 	private TextWithLabelElement text_catalogNumber;
 
-	private NameSelectionElement selection_storedUnder;
+	private EntitySelectionElement<TaxonNameBase> selection_storedUnder;
 
 	private TextWithLabelElement text_exsicatum;
 
@@ -54,8 +55,6 @@ public class DerivedUnitBaseDetailElement extends
 
 	private SourceCollectionDetailSection section_source;
 
-	private TextWithLabelElement text_collectorsNumber;
-
 	/**
 	 * <p>
 	 * Constructor for DerivedUnitBaseDetailElement.
@@ -98,10 +97,10 @@ public class DerivedUnitBaseDetailElement extends
 			// we ignore this
 			StoreUtil.info(e.getMessage());
 		}
-		selection_storedUnder = (NameSelectionElement) formFactory
-				.createSelectionElement(SelectionType.NAME,
+		selection_storedUnder = formFactory
+				.createSelectionElement(TaxonNameBase.class,
 						getConversationHolder(), formElement, "Stored Under",
-						entity.getStoredUnder(), NameSelectionElement.DEFAULT,
+						entity.getStoredUnder(), EntitySelectionElement.ALL,
 						style);
 
 		try {
@@ -117,14 +116,14 @@ public class DerivedUnitBaseDetailElement extends
 						EntityDetailType.SPECIMEN_COLLECTION,
 						getConversationHolder(), formElement, Section.TWISTIE);
 		section_duplicates
-				.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+				.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		section_duplicates.setEntity(entity);
 
 		section_source = (SourceCollectionDetailSection) formFactory
 				.createEntityDetailSection(
 						EntityDetailType.IDENTIFIABLE_SOURCE_COLLECTION,
 						getConversationHolder(), formElement, Section.TWISTIE);
-		section_source.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_source.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		section_source.setEntity(entity);
 	}
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitBaseWizardPage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitBaseWizardPage.java
index 8542621b3..3524daad5 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitBaseWizardPage.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitBaseWizardPage.java
@@ -16,8 +16,8 @@ import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
 import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 
 /**
@@ -51,7 +51,7 @@ public class DerivedUnitBaseWizardPage extends AbstractCdmEntityWizardPage<Deriv
 	 * @see eu.etaxonomy.taxeditor.forms.AbstractCdmEntityWizardPage#createElement(eu.etaxonomy.taxeditor.forms.ICdmFormElement)
 	 */
 	@Override
-	public AbstractCdmDetailElement createElement(ICdmFormElement rootElement) {
+	public AbstractCdmDetailElement<DerivedUnitFacade> createElement(ICdmFormElement rootElement) {
 		DerivedUnitBaseDetailElement detailElement = (DerivedUnitBaseDetailElement) formFactory.createCdmDetailElement(DetailType.DERIVED_UNIT, rootElement, SWT.NULL);
 		detailElement.setEntity(getEntity());		
 		return detailElement;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitFacadeDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitFacadeDetailElement.java
index 17c1cbf0b..937ee2113 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitFacadeDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitFacadeDetailElement.java
@@ -20,6 +20,7 @@ import eu.etaxonomy.taxeditor.store.StoreUtil;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
 
@@ -119,22 +120,22 @@ public class DerivedUnitFacadeDetailElement extends AbstractCdmDetailElement<Der
 			DerivedUnitBase entity, int style) {
 		
 		section_general = (GeneralDetailSection) formFactory.createCdmDetailSection(DetailType.DERIVED_UNIT_GENERAL, getConversationHolder(), formElement, null, Section.TWISTIE | Section.EXPANDED);
-		section_general.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_general.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		addControl(section_general);
 		addElement(section_general);
 		
 		section_gatheringEvent = (GatheringEventDetailSection) formFactory.createCdmDetailSection(DetailType.GATHERING_EVENT, getConversationHolder(), formElement, null, Section.TWISTIE);
-		section_gatheringEvent.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_gatheringEvent.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		addControl(section_gatheringEvent);
 		addElement(section_gatheringEvent);
 		
 		section_fieldObservation = (FieldObservationDetailSection) formFactory.createCdmDetailSection(DetailType.FIELD_OBSERVATION, getConversationHolder(), formElement, null, Section.TWISTIE);
-		section_fieldObservation.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_fieldObservation.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		addControl(section_fieldObservation);
 		addElement(section_fieldObservation);
 		
 		section_derivedUnitBase = (DerivedUnitBaseDetailSection) formFactory.createCdmDetailSection(DetailType.DERIVED_UNIT, getConversationHolder(), formElement, null, Section.TWISTIE);
-		section_derivedUnitBase.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_derivedUnitBase.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		addControl(section_derivedUnitBase);
 		addElement(section_derivedUnitBase);
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitFacadeDetailSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitFacadeDetailSection.java
index c97bf105a..c099a4d20 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitFacadeDetailSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DerivedUnitFacadeDetailSection.java
@@ -10,14 +10,13 @@
 
 package eu.etaxonomy.taxeditor.ui.section.occurrence;
 
-import org.apache.log4j.Logger;
 import org.eclipse.jface.viewers.ISelectionProvider;
 
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
 
 /**
@@ -29,10 +28,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
  */
 public class DerivedUnitFacadeDetailSection extends AbstractCdmDetailSection<DerivedUnitBase> {
 	
-
-	private static final Logger logger = Logger
-			.getLogger(DerivedUnitFacadeDetailSection.class);
-
 	/**
 	 * <p>Constructor for DerivedUnitFacadeDetailSection.</p>
 	 *
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DeterminationDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DeterminationDetailElement.java
index 6c6346183..7fdfd02f1 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DeterminationDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DeterminationDetailElement.java
@@ -16,6 +16,7 @@ import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 
 /**
@@ -49,14 +50,14 @@ public class DeterminationDetailElement extends AbstractCdmDetailElement<Derived
 				.createEntityDetailSection(
 						EntityDetailType.DETERMINATION_CURRENT,
 						getConversationHolder(), formElement, Section.EXPANDED);
-		section_currentDetermination.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_currentDetermination.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		section_currentDetermination.setEntity(entity);
 		
 		section_determinationHistory = (DeterminationHistoryDetailSection) formFactory
 											.createEntityDetailSection(
 													EntityDetailType.DETERMINATION_HISTORY,
 													getConversationHolder(), formElement, Section.TWISTIE);
-		section_determinationHistory.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_determinationHistory.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		section_determinationHistory.setEntity(entity);
 		
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DeterminationEventDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DeterminationEventDetailElement.java
index a8330fc88..92c0533da 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DeterminationEventDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/DeterminationEventDetailElement.java
@@ -14,14 +14,13 @@ import org.eclipse.swt.events.SelectionListener;
 
 import eu.etaxonomy.cdm.model.occurrence.DeterminationEvent;
 import eu.etaxonomy.cdm.model.occurrence.DeterminationModifier;
+import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.CheckboxElement;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
-import eu.etaxonomy.taxeditor.ui.selection.TaxonBaseSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.TaxonSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -37,7 +36,7 @@ public class DeterminationEventDetailElement extends
 
 	private TermComboElement<DeterminationModifier> combo_determinationModifier;
 	private CheckboxElement checkbox_preferredFlag;
-	private TaxonBaseSelectionElement selection_taxonBase;
+	private EntitySelectionElement<TaxonBase> selection_taxonBase;
 
 	// private TODO a set of references
 
@@ -92,10 +91,10 @@ public class DeterminationEventDetailElement extends
 	/** {@inheritDoc} */
 	@Override
 	public void createControls(ICdmFormElement element, int style) {
-		selection_taxonBase = (TaxonBaseSelectionElement) formFactory
-				.createSelectionElement(SelectionType.TAXON_BASE,
+		selection_taxonBase = formFactory
+				.createSelectionElement(TaxonBase.class,
 						getConversationHolder(), element, "Taxon", null,
-						TaxonSelectionElement.DEFAULT, style);
+						EntitySelectionElement.NOTHING, style);
 		
 
 		// TODO set of references
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/FieldObservationWizardPage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/FieldObservationWizardPage.java
index 19edb2563..803e71355 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/FieldObservationWizardPage.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/FieldObservationWizardPage.java
@@ -16,8 +16,8 @@ import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
 import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 
 /**
@@ -51,7 +51,7 @@ public class FieldObservationWizardPage extends AbstractCdmEntityWizardPage<Deri
 	 * @see eu.etaxonomy.taxeditor.forms.AbstractCdmEntityWizardPage#createElement(eu.etaxonomy.taxeditor.forms.ICdmFormElement)
 	 */
 	@Override
-	public AbstractCdmDetailElement createElement(ICdmFormElement rootElement) {
+	public AbstractCdmDetailElement<DerivedUnitFacade> createElement(ICdmFormElement rootElement) {
 		FieldObservationDetailElement detailElement = (FieldObservationDetailElement) formFactory.createCdmDetailElement(DetailType.FIELD_OBSERVATION, rootElement, SWT.NONE);
 		detailElement.setEntity(getEntity());
 		return detailElement;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GatheringEventDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GatheringEventDetailElement.java
index 7e6362585..38eabcf2e 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GatheringEventDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GatheringEventDetailElement.java
@@ -16,11 +16,11 @@ import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
 import eu.etaxonomy.taxeditor.preference.Resources;
 import eu.etaxonomy.taxeditor.store.StoreUtil;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.CdmPropertyChangeEvent;
+import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.element.NumberWithLabelElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 
 /**
@@ -107,7 +107,7 @@ public class GatheringEventDetailElement extends
 		section_collectingAreas = (CollectingAreasDetailSection) formFactory
 				.createEntityDetailSection(EntityDetailType.COLLECTING_AREA,
 						getConversationHolder(), formElement, Section.TWISTIE);
-		section_collectingAreas.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(
+		section_collectingAreas.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(
 				2, 1));
 		section_collectingAreas.setEntity(entity);
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GatheringEventWizardPage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GatheringEventWizardPage.java
index 20afc0bb2..54dd833b1 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GatheringEventWizardPage.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GatheringEventWizardPage.java
@@ -16,8 +16,8 @@ import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
 import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 
 /**
@@ -51,7 +51,7 @@ public class GatheringEventWizardPage extends AbstractCdmEntityWizardPage<Derive
 	 * @see eu.etaxonomy.taxeditor.forms.AbstractCdmEntityWizardPage#createElement(eu.etaxonomy.taxeditor.forms.ICdmFormElement)
 	 */
 	@Override
-	public AbstractCdmDetailElement createElement(ICdmFormElement rootElement) {
+	public AbstractCdmDetailElement<DerivedUnitFacade> createElement(ICdmFormElement rootElement) {
 		GatheringEventDetailElement detailElement = (GatheringEventDetailElement) formFactory.createCdmDetailElement(DetailType.GATHERING_EVENT, rootElement, SWT.NULL);
 		detailElement.setEntity(getEntity());
 		return detailElement;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GeneralDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GeneralDetailElement.java
index 0e2dcfb63..5951b23db 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GeneralDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GeneralDetailElement.java
@@ -11,8 +11,10 @@
 package eu.etaxonomy.taxeditor.ui.section.occurrence;
 
 import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
+import eu.etaxonomy.cdm.model.agent.AgentBase;
 import eu.etaxonomy.cdm.model.common.LanguageString;
-import eu.etaxonomy.taxeditor.store.CdmStore;
+import eu.etaxonomy.cdm.model.location.NamedArea;
+import eu.etaxonomy.cdm.model.occurrence.Collection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.LanguageStringWithLabelElement;
@@ -21,11 +23,8 @@ import eu.etaxonomy.taxeditor.ui.element.PointElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
 import eu.etaxonomy.taxeditor.ui.element.TimePeriodElement;
 import eu.etaxonomy.taxeditor.ui.element.ToggleableTextElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.AgentSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.CollectionSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.NamedAreaSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * @author n.hoffmann
@@ -37,14 +36,14 @@ public class GeneralDetailElement extends
 
 	private ToggleableTextElement toggleableText_titleCache;
 
-	private NamedAreaSelectionElement selection_country;
+	private EntitySelectionElement<NamedArea> selection_country;
 	private LanguageStringWithLabelElement languageText_locality;
 	private PointElement element_point;
 	private NumberWithLabelElement number_elevation;
 	private TimePeriodElement element_date;
-	private AgentSelectionElement selection_collector;
+	private EntitySelectionElement<AgentBase> selection_collector;
 	private TextWithLabelElement text_collectingNumber;
-	private CollectionSelectionElement selection_collection;
+	private EntitySelectionElement<Collection> selection_collection;
 	private TextWithLabelElement text_barcode;
 
 	/**
@@ -70,9 +69,9 @@ public class GeneralDetailElement extends
 				formElement, "Title Cache", entity.getTitleCache(),
 				entity.isProtectedTitleCache(), style);
 
-		selection_country = formFactory.createNamedAreaSelectionElement(
-				formElement, getConversationHolder(), "Country",
-				entity.getCountry(), style);
+		selection_country = formFactory.createSelectionElement(NamedArea.class, getConversationHolder(),
+				formElement, "Country",
+				entity.getCountry(), EntitySelectionElement.NOTHING, style);
 		languageText_locality = formFactory
 				.createLanguageStringWithLabelElement(formElement, "Locality",
 						entity.getLocality(), style);		
@@ -83,18 +82,18 @@ public class GeneralDetailElement extends
 				entity.getAbsoluteElevation(), style);
 		element_date = formFactory.createTimePeriodElement(formElement, "Date",
 				entity.getGatheringPeriod(), style);
-		selection_collector = (AgentSelectionElement) formFactory
-				.createSelectionElement(SelectionType.AGENT,
+		selection_collector = formFactory
+				.createSelectionElement(AgentBase.class,
 						getConversationHolder(), formElement, "Collector",
-						entity.getCollector(), AgentSelectionElement.DEFAULT,
+						entity.getCollector(), EntitySelectionElement.ALL,
 						style);
 		text_collectingNumber = formFactory.createTextWithLabelElement(formElement,
 				"Collecting number", entity.getFieldNumber(), style);
-		selection_collection = (CollectionSelectionElement) formFactory
-				.createSelectionElement(SelectionType.COLLECTION,
+		selection_collection = formFactory
+				.createSelectionElement(Collection.class,
 						getConversationHolder(), formElement, "Collection",
 						entity.getCollection(),
-						CollectionSelectionElement.DEFAULT, style);
+						EntitySelectionElement.ALL, style);
 		text_barcode = formFactory.createTextWithLabelElement(formElement,
 				"Barcode", entity.getBarcode(), style);
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GeneralWizardPage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GeneralWizardPage.java
index 0919df87a..9b1224a0d 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GeneralWizardPage.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/GeneralWizardPage.java
@@ -16,8 +16,8 @@ import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.api.facade.DerivedUnitFacade;
 import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 
 /**
@@ -50,7 +50,7 @@ public class GeneralWizardPage extends AbstractCdmEntityWizardPage<DerivedUnitFa
 	 * @see eu.etaxonomy.taxeditor.forms.AbstractCdmEntityWizardPage#createElement(eu.etaxonomy.taxeditor.forms.ICdmFormElement)
 	 */
 	@Override
-	public AbstractCdmDetailElement createElement(ICdmFormElement rootElement) {
+	public AbstractCdmDetailElement<DerivedUnitFacade> createElement(ICdmFormElement rootElement) {
 		GeneralDetailElement detailElement = (GeneralDetailElement) formFactory.createCdmDetailElement(DetailType.DERIVED_UNIT_GENERAL, rootElement, SWT.NULL);
 		detailElement.setEntity(getEntity());
 		checkComplete();
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/NamedAreaDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/NamedAreaDetailElement.java
index 661d6c630..021e68273 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/NamedAreaDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/NamedAreaDetailElement.java
@@ -17,7 +17,7 @@ import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.NamedAreaSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -31,7 +31,7 @@ import eu.etaxonomy.taxeditor.ui.selection.NamedAreaSelectionElement;
 public class NamedAreaDetailElement extends
 		AbstractEntityCollectionElement<NamedArea> {
 
-	private NamedAreaSelectionElement selection_namedArea;
+	private EntitySelectionElement<NamedArea> selection_namedArea;
 
 	/**
 	 * <p>
@@ -79,9 +79,10 @@ public class NamedAreaDetailElement extends
 	 */
 	/** {@inheritDoc} */
 	@Override
-	public void createControls(ICdmFormElement element, int style) {
-		selection_namedArea = formFactory.createNamedAreaSelectionElement(
-				element, getConversationHolder(), "Area", null, style);
+	public void createControls(ICdmFormElement formElement, int style) {
+		selection_namedArea = formFactory.createSelectionElement(NamedArea.class, getConversationHolder(),
+				formElement, "Area",
+				null, EntitySelectionElement.NOTHING, style);
 	}
 
 	/*
